
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>在SpringMVC中使用拦截器（interceptor）拦截CSRF攻击 / 憋错料</title>

    <meta name="description" content="在SpringMVC中使用拦截器（interceptor）拦截CSRF攻击 关于什么是CSRF我这里就不多说了,以前转载的一篇文章(PS:https://www.zifangsky.cn/358.html)已经说得很清楚了.这里只是简单介绍如何在SpringMVC中使用拦截器拦截CSRF攻击.具体代码如下: (1)登录页面: &lt;%@page import=&quot;java.security.SecureRandom&quot;%&gt; &lt;%@ page language=&quot;java&quot; contentType=&quot;text/h ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">在SpringMVC中使用拦截器（interceptor）拦截CSRF攻击</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>关于什么是CSRF我这里就不多说了，以前转载的一篇文章（PS：<a href="https://www.zifangsky.cn/358.html" rel="external nofollow noreferrer">https://www.zifangsky.cn/358.html</a>）已经说得很清楚了。这里只是简单介绍如何在SpringMVC中使用拦截器拦截CSRF攻击。具体代码如下：</p>
<p>（1）登录页面：</p>
<pre>&lt;%@page&nbsp;import="java.security.SecureRandom"%&gt;
&lt;%@&nbsp;page&nbsp;language="java"&nbsp;contentType="text/html;&nbsp;charset=UTF-8"
&nbsp;&nbsp;&nbsp;&nbsp;pageEncoding="UTF-8"%&gt;
&lt;%
String&nbsp;path&nbsp;=&nbsp;request.getContextPath();
String&nbsp;basePath&nbsp;=&nbsp;request.getScheme()+"://"+request.getServerName()+":"+request.getServerPort()+path+"/";
%&gt;&nbsp;&nbsp;&nbsp;&nbsp;
&lt;html&gt;
&lt;head&gt;
&lt;meta&nbsp;http-equiv="Content-Type"&nbsp;content="text/html;&nbsp;charset=UTF-8"&gt;
&lt;base&nbsp;href="&lt;%=basePath%&gt;"&gt;
&lt;title&gt;SpringMVC&nbsp;Cookie&nbsp;Demo&lt;/title&gt;
&lt;%
	SecureRandom&nbsp;random&nbsp;=&nbsp;new&nbsp;SecureRandom();
	random.setSeed(8738);
	double&nbsp;_csrf&nbsp;=&nbsp;random.nextDouble();
	session.setAttribute("_csrf",&nbsp;_csrf);
%&gt;
&lt;/head&gt;
&lt;body&gt;
	&lt;div&nbsp;align="center"&gt;
		&lt;h2&gt;SpringMVC&nbsp;Cookie&nbsp;Demo&lt;/h2&gt;
		&lt;form&nbsp;action="check.html"&nbsp;method="post"&gt;
			&lt;table&gt;
				&lt;tr&gt;
					&lt;td&gt;用户名：&lt;/td&gt;
					&lt;td&gt;&lt;input&nbsp;type="text"&nbsp;name="username"&nbsp;/&gt;&lt;/td&gt;
				&lt;/tr&gt;
				&lt;tr&gt;
					&lt;td&gt;密码：&lt;/td&gt;
					&lt;td&gt;&lt;input&nbsp;type="password"&nbsp;name="password"&nbsp;/&gt;&lt;/td&gt;
				&lt;/tr&gt;
				&lt;tr&gt;
					&lt;td&gt;&lt;input&nbsp;name="remember-me"&nbsp;type="checkbox"&gt;30天内自动登录&lt;/input&gt;&lt;/td&gt;
				&lt;/tr&gt;
				&lt;tr&gt;
					&lt;td&nbsp;colspan="2"&nbsp;align="center"&gt;&lt;input&nbsp;type="submit"&nbsp;value="登录"&nbsp;/&gt;
						&lt;input&nbsp;type="reset"&nbsp;value="重置"&nbsp;/&gt;&lt;/td&gt;
				&lt;/tr&gt;
			&lt;/table&gt;
			&lt;input&nbsp;type="hidden"&nbsp;name="_csrf"&nbsp;value="&lt;%=_csrf&nbsp;%&gt;"&nbsp;/&gt;
		&lt;/form&gt;

	&lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>
<p>从上面的代码可知，为了防止CSRF攻击，因此在form表单里添加了一个隐藏字段“_csrf”，其值是生成的一个随机小数</p>
<p>（2）在SpringMVC的配置文件中添加拦截器：</p>
<pre>&lt;?xml&nbsp;version="1.0"&nbsp;encoding="UTF-8"?&gt;
&lt;beans&nbsp;xmlns="http://www.springframework.org/schema/beans"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"&nbsp;xmlns:context="http://www.springframework.org/schema/context"
	xmlns:cache="http://www.springframework.org/schema/cache"
	xmlns:mvc="http://www.springframework.org/schema/mvc"
	xsi:schemaLocation="http://www.springframework.org/schema/beans&nbsp;
	&nbsp;&nbsp;&nbsp;http://www.springframework.org/schema/beans/spring-beans-4.0.xsd
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://www.springframework.org/schema/context&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://www.springframework.org/schema/context/spring-context-4.0.xsd
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://www.springframework.org/schema/cache&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://www.springframework.org/schema/cache/spring-cache-4.0.xsd&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://www.springframework.org/schema/mvc&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;http://www.springframework.org/schema/mvc/spring-mvc-4.0.xsd"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default-lazy-init="true"&gt;

	&lt;mvc:annotation-driven&nbsp;/&gt;
	&lt;!--&nbsp;组件扫描&nbsp;--&gt;
	&lt;context:component-scan&nbsp;base-package="cn.zifangsky.controller"&nbsp;/&gt;
	&lt;context:component-scan&nbsp;base-package="cn.zifangsky.manager.impl"/&gt;
	&lt;!--&nbsp;配置直接转发的页面&nbsp;--&gt;
	&lt;mvc:view-controller&nbsp;path="/login.html"&nbsp;view-name="login"&nbsp;/&gt;
	&lt;mvc:view-controller&nbsp;path="/user/callback.html"&nbsp;view-name="user/callback"&nbsp;/&gt;

	&lt;!--&nbsp;拦截器&nbsp;--&gt;
	&lt;mvc:interceptors&gt;
		&lt;mvc:interceptor&gt;
			&lt;!--&nbsp;对登录操作进行拦截&nbsp;--&gt;
			&lt;mvc:mapping&nbsp;path="/check.html"/&gt;
			&lt;bean&nbsp;class="cn.zifangsky.interceptor.LoginInterceptor"&nbsp;/&gt;
		&lt;/mvc:interceptor&gt;
		&lt;mvc:interceptor&gt;
			&lt;!--&nbsp;对/user/**的请求进行拦截&nbsp;--&gt;
			&lt;mvc:mapping&nbsp;path="/user/**"/&gt;
			&lt;bean&nbsp;class="cn.zifangsky.interceptor.UserInterceptor"&nbsp;/&gt;
		&lt;/mvc:interceptor&gt;
	&lt;/mvc:interceptors&gt;

	&lt;!--&nbsp;视图解析&nbsp;--&gt;
	&lt;bean
		class="org.springframework.web.servlet.view.InternalResourceViewResolver"&gt;
		&lt;property&nbsp;name="prefix"&nbsp;value="/WEB-INF/pages/"&nbsp;/&gt;
		&lt;property&nbsp;name="suffix"&nbsp;value=".jsp"&nbsp;/&gt;
	&lt;/bean&gt;
&lt;/beans&gt;</pre>
<p>从上面的代码知道，在这个文件中添加了一个&nbsp;mvc:interceptors 标签，表示一系列的拦截器集合，然后下面定义了对登录时form表单提交地址“/check.html”进行拦截。下面一行的bean属性就是定义了自定义拦截器的类所在的路径</p>
<p>注：后面那个拦截器这里不用管，我在写后面的文章时才会用到</p>
<p>（3）自定义拦截器LoginInterceptor：</p>
<pre>package&nbsp;cn.zifangsky.interceptor;

import&nbsp;javax.servlet.http.HttpServletRequest;
import&nbsp;javax.servlet.http.HttpServletResponse;
import&nbsp;javax.servlet.http.HttpSession;

import&nbsp;org.apache.commons.lang3.StringUtils;
import&nbsp;org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

public&nbsp;class&nbsp;LoginInterceptor&nbsp;extends&nbsp;HandlerInterceptorAdapter&nbsp;{
	/**
	&nbsp;*&nbsp;用于在登录前验证&nbsp;_csrf&nbsp;参数
	&nbsp;*&nbsp;*/
	public&nbsp;boolean&nbsp;preHandle(HttpServletRequest&nbsp;request,&nbsp;HttpServletResponse&nbsp;response,&nbsp;Object&nbsp;handler)
			throws&nbsp;Exception&nbsp;{
		HttpSession&nbsp;session&nbsp;=&nbsp;request.getSession();
		String&nbsp;_csrfByForm&nbsp;=&nbsp;request.getParameter("_csrf");&nbsp;&nbsp;//表单中的值
		String&nbsp;_csrfBySession&nbsp;=&nbsp;String.valueOf(session.getAttribute("_csrf"));&nbsp;&nbsp;//session中的值
		session.removeAttribute("_csrf");&nbsp;&nbsp;//使用之后从session中删掉

		//验证是否存在CSRF攻击
		if(StringUtils.isNotBlank(_csrfByForm)&nbsp;&amp;&amp;&nbsp;StringUtils.isNotBlank(_csrfBySession)&nbsp;&amp;&amp;&nbsp;_csrfByForm.equals(_csrfBySession)){
			return&nbsp;true;
		}else{
			response.setContentType("text/html;charset=utf-8");
			response.setStatus(403);

			//页面友好提示信息
			OutputStream&nbsp;oStream&nbsp;=&nbsp;response.getOutputStream();
			oStream.write("请不要重复提交请求，返回原始页面刷新后再次尝试！！！".getBytes("UTF-8"));

			return&nbsp;false;
		}
	}

	public&nbsp;void&nbsp;afterCompletion(HttpServletRequest&nbsp;request,&nbsp;HttpServletResponse&nbsp;response,&nbsp;Object&nbsp;handler,&nbsp;Exception&nbsp;ex)
			throws&nbsp;Exception&nbsp;{
		super.afterCompletion(request,&nbsp;response,&nbsp;handler,&nbsp;ex);
	}

}</pre>
<p>这个自定义拦截器的逻辑很简单，就是把form表单隐藏域“_csrf”中的值和session中的“_csrf”值进行比较。如果二者相同，则说明该请求是从前台form表单中传进来的，而不是其他网站的伪造请求（PS：因为这种方式没法向session中定义“_csrf”参数）；同时也防止form表单的重复提交（PS：因为第一次验证过后session中的“_csrf”就已经被移除了，除非前台刷新页面才会重新生成），避免了爆破撞库等安全隐患。当然，为了进一步降低安全隐患，这里的form表单还应该添加复杂的动态验证码。我这里是由于为了让示例更简洁，因此就把这一步给省略了</p>
<p>（4）验证：</p>
<p>第一次提交表单，发现可以正常到达后台进行验证</p>
<p>第二次点击浏览器的“返回键”，返回到表单页面之后重复提交，可以发现直接被拦截了。效果如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEEvRDAvd0tpb0wxZzg1S2ZDYml1c0FBQnA5U1Z1OE1zNTY3LnBuZw==.jpg" /></p>
<p>PS：上面图片中的水印是我个人博客的域名，因此还请管理员手下留情不要给我标为“转载文章”，谢谢！！！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-18 18:52:10 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/csrf-interceptor-springmvc/" title="csrf interceptor springmvc">csrf interceptor springmvc</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>在SpringMVC中使用拦截器（interceptor）拦截CSRF攻击的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02OdEo3.html" rel="bookmark">Struts拦截器Interceptor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Struts2 拦截器 [Interceptor] 拦截器的工作原理如上图,每一个Action请求都包装在一系列的拦截器的内部.拦截器可以在Action执行直线做相似的操作也可以在Action执行直后做回收操作. 每一个Action既可以将操作转交给下面的拦截器,Action也可以直接退出操作返回客户既定的画面. 如何自定义一个拦截器? 自定义一个拦截器需要三步: 1 自定义一个实现Interceptor接口(或者继承自AbstractInterceptor)的类. 2 在strutx.xml中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y2kAr3.html" rel="bookmark">Struts2-整理笔记（五）拦截器、拦截器配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				拦截器(Interceptor) 拦截器是Struts2最强大的特性之一,它是一种可以让用户在Action执行之前和Result执行之后进行一些功能处理的机制. 拦截器的优点 简化了Action的实现.拦截器能把很多功能从Action中独立出来,大量减少了Action的代码 功能更单一.按照上面的描述,把功能从Action中分离出来,分散到不同的拦截器中,这样每个拦截器的功能,以及Action本身的功能就更单一了. 通用代码模块化.从Action中把功能分离出来,放到拦截器中去实现,这样能把一些			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35rGbv4.html" rel="bookmark">详述 Spring MVC 框架中拦截器 Interceptor 的使用方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 前言 昨天新接了一个需要,&quot;拦截 XXX,然后 OOO&quot;,好吧,说白了就是要用拦截器干点事(实现一个具体的功能).之前,也在网络上搜了很多关于Interceptor的文章,但感觉内容都大同小异,而且知识点零零散散,不太方便阅读.因此,正好借此机会,整理一篇关于拦截器的文章,在此分享给大家,以供大家参考阅读. 2 拦截器 2.1 概念 Java 里的拦截器是动态拦截 action 调用的对象.它提供了一种机制可以使开发者可以定义在一个 action 执行的前后执行的代码,也可以在一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MV9gRd4.html" rel="bookmark">Spring MVC中的拦截器Interceptor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				谈谈spring中的拦截器 在web开发中,拦截器是经常用到的功能.它可以帮我们验证是否登陆.预先设置数据以及统计方法的执行效率等等.今天就来详细的谈一下spring中的拦截器.spring中拦截器主要分两种,一个是HandlerInterceptor,一个是MethodInterceptor. 一,HandlerInterceptor拦截器 HandlerInterceptor是springMVC项目中的拦截器,它拦截的目标是请求的地址,比MethodInterceptor先执行.实现一个Ha			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0d2jm64.html" rel="bookmark">SpringMVC拦截器&lowbar;1&lowbar;拦截器的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SpringMVC interceptor:下列参考的blog文章 Spring MVC简介 SpringMVC 拦截器实现原理和登录实现 SpringMVC拦截器详解[附带源码分析] 学习SpringMVC--拦截器 ********************* 1-1 拦截器 拦截器是指通过统一拦截从浏览器发往服务器的请求来完成功能的增强. 使用场景:解决请求的共性问题(如:乱码问题,权限验证等) ===2 拦截器的实现========================== ---2-1 拦截器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e1Vqg0.html" rel="bookmark">SpringMVC&lowbar;拦截器 interceptor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:拦截器 拦截器是SpringMvc中提供的一种于 Filter 类似的过滤器技术,但拦截器智能拦截Controller的请求,而Filter 可以过滤所有的请求 创建一个拦截器 1:创建一个普通类,实现HandlerInterceptor接口 package com.doaoao.interceptor; import org.springframework.web.servlet.HandlerInterceptor; import org.springframework.web.serv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQkPj3.html" rel="bookmark">Flume-NG源码阅读之SourceRunner，及选择器selector和拦截器interceptor的执行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在AbstractConfigurationProvider类中loadSources方法会将所有的source进行封装成SourceRunner放到了Map&lt;String, SourceRunner&gt; sourceRunnerMap之中.相关代码如下: 1 Map&lt;String, String&gt; selectorConfig = context.getSubProperties( 2 BasicConfigurationConstants.CONFIG_SOURCE_CHANNE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoxZYx0.html" rel="bookmark">Kafka producer拦截器&lpar;interceptor&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Producer拦截器(interceptor)是个相当新的功能,它和consumer端interceptor是在Kafka 0.10版本被引入的,主要用于实现clients端的定制化控制逻辑. 对于producer而言,interceptor使得用户在消息发送前以及producer回调逻辑前有机会对消息做一些定制化需求,比如修改消息等.同时,producer允许用户指定多个interceptor按序作用于同一条消息从而形成一个拦截链(interceptor chain).Intercetpor			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ebyPg3.html" rel="bookmark">Struts2拦截器、拦截器栈&lpar;Interceptor Stack&rpar;、全局拦截器与方法拦截器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Struts2拦截器原理 Struts2拦截器是在访问某个Action或Action的方法之前或之后实施拦截.在请求Struts2的Action时,Struts2会查找配置文件,并根据配置文件实例化相应的拦截器对象. Struts2拦截器配置 struts.xml &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;!DOCTYPE struts PUBLIC &quot;-//Apache Software Found			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pO12g3.html" rel="bookmark">struts2拦截器interceptor的三种配置方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				struts2拦截器interceptor的三种配置方法方法1. 普通配置法 &lt;struts&gt;     &lt;package name=&quot;struts2&quot; extends=&quot;struts-default&quot;&gt;         &lt;interceptors&gt;             &lt;interceptor name=&quot;myInterceptor&quot; class=&quot;edu.hust.interceptor.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4JXWP0.html" rel="bookmark" class="title">Python中re&lpar;正则表达式&rpar;模块函数学习</a>
					<div>
						今天学习了Python中有关正则表达式的知识.关于正则表达式的语法,不作过多解释,网上有许多学习的资料.这里主要介绍Python中常用的正则表达式处理函数. 方法/属性 作用 match() 决定 R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPNpLm3.html" rel="bookmark" class="title">【转】每天一个linux命令（36）：diff 命令</a>
					<div>
						原文网址:http://www.cnblogs.com/peida/archive/2012/12/12/2814048.html diff 命令是 linux上非常重要的工具,用于比较文件的内容,特 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWy5VL3.html" rel="bookmark" class="title">sql中 with rollup 、with cube、grouping 统计函数用法</a>
					<div>
						with rollup .with cube.grouping CUBE 和 ROLLUP 之间的区别在于: CUBE 生成的结果集显示了所选列中值的所有组合的聚合. ROLLUP 生成的结果集显示了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nEgvxM.html" rel="bookmark" class="title">实验三实验报告20135219洪韶武  20135201李辰希</a>
					<div>
						北京电子科技学院(BESTI) 实     验    报     告 课程:信息安全系统设计基础                       班级:1352 姓名:  洪韶武        李辰希 学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdPpmM.html" rel="bookmark" class="title">面试题：找出数组中只出现一次的数字</a>
					<div>
						难度:中等 一个整数数组,除了一个数之外所有数字都出现了2次,找出这个数字来. 注意: 你的算法应该是线性运行复杂度,且不能使用额外内存空间. 答案: public class Solution {  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nEzmXM.html" rel="bookmark" class="title">POJ 3667 Hotel（区间合并）</a>
					<div>
						题目链接:http://poj.org/problem?id=3667 题意:宾馆有n个房间.有人来入住.共有2种操作 输入1和d,表示查询最左的连续d个空房间数的起始位置. 输入2,x和d,表示将从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWAjxa3.html" rel="bookmark" class="title">什么时候会执行viewDidLoad方法</a>
					<div>
						这个博文是为了解释,为何有时候,你给属性赋值,在viewDidLoad方法中却取不到值的原因. 第一种情况,presentViewController会执行被present的控制器的viewDidLo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RY91PM.html" rel="bookmark" class="title">C&num;获取WIN系统进程信息</a>
					<div>
						private void button1_Click(object sender, EventArgs e) { listBox_thread_list.Items.Clear(); Process[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZ52XM.html" rel="bookmark" class="title">【算法设计与分析】9、最小生成树，贪心算法实现</a>
					<div>
						/** * 书本:&lt;算法分析与设计&gt; * 功能:实现用Prim算法实现寻找最小生成树 * 文件:PrimMixTree.cpp * 时间:2015年1月4日19:42:57 * 作者:cu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mzEy0.html" rel="bookmark" class="title">MFC EDIT 自动换行</a>
					<div>
						Vertical Scroll = TRUEMultiLine = TRUEHorizontal Scroll = FALSEAuto HScroll = FALSE可选设置Want Return = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myl7ga4.html" rel="bookmark" class="title">高斯核函数</a>
					<div>
						高斯核函数 所谓径向基函数 (Radial Basis Function 简称 RBF), 就是某种沿径向对称的标量函数.通常定义为空间中任一点x到某一中心xc之间欧氏距离的单调函数 , 可记作 k( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vjvGo3.html" rel="bookmark" class="title">爱，需要正确的时间</a>
					<div>
						一个女人突然决绝的跟相爱五年的男友分了手,闪电般嫁了他人. 她说她要结婚她实在等不起了,而他虽然爱她,却根本没有一点这方面的意思. 过了几年,男人也结婚了. 那个新娘其实未必比她出色多少,或者这一次他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JvKzA4.html" rel="bookmark" class="title">强将手下无弱兵</a>
					<div>
						人之间能力的差异是客观的,能力不高的时候也不必太过苦恼.能力的取得有许多因素,有些因素人好把控有些则是一些机遇与运气,如果能够把可把控的利用好那就相当不错了,取得一个较为满意的程度不成太大的问题.可有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j2N990.html" rel="bookmark" class="title">运行eclipse就提示 The Eclipse executable launcher was unable to locate its companion library&period; 解决方案</a>
					<div>
						你试试把中文路径换掉 不行的话参考 逝去的青春的博客:Eclipse出现“The Eclipse executable launcher was unable to locate its compan ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGdgpQ0.html" rel="bookmark" class="title">&lbrack;转&rsqb;毕设- 深入HBase架构解析（二）</a>
					<div>
						深入HBase架构解析(二) 前言 这是&lt;深入HBase架构解析(一)&gt;的续,不多废话,继续.... HBase读的实现 通过前文的描述,我们知道在HBase写时,相同Cell(RowKe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QjQQlM.html" rel="bookmark" class="title">java 传入用户名和密码并自动提交表单实现登录到其他系统</a>
					<div>
						不用单点登录,模拟远程项目的登录页面表单,在访问这个页面的时候自动提交表单到此项目的登录action,就可以实现登录到其他系统. ssh框架项目 1.以下是本地系统的action代码: 1 impor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyyYKM.html" rel="bookmark" class="title">11个高级MySQL数据库面试问题和答案</a>
					<div>
						因为有大家的支持,我们才能做到现在,感谢你们这一路上对我们的支持.在这篇文章中,我们将主要针对MySQL的实用技巧,讲讲面试中相关的问题. 1. 如何使用SELECT语句找到你正在运行的服务器的版本并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBBKL4.html" rel="bookmark" class="title">NPOI导出数据到Excel</a>
					<div>
						NPOI导出数据到Excel 前言 Asp.net操作Excel已经是老生长谈的事情了,可下面我说的这个NPOI操作Excel,应该是最好的方案了,没有之一,使用NPOI能够帮助开发者在没有安装微软O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXZZwk3.html" rel="bookmark" class="title">计算机编码</a>
					<div>
						编码是信息从一种形式或格式转换为另一种形式的过程也称为计算机编程语言的代码简称编码.用预先规定的方法将文字.数字或其它对象编成数码,或将信息.数据转换成规定的电脉冲信号.编码在电子计算机.电视.遥控和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4N18jo3.html" rel="bookmark" class="title">【NOIP 2012 国王游戏】 贪心&plus;高精度</a>
					<div>
						题目描述 恰逢 H 国国庆,国王邀请 n 位大臣来玩一个有奖游戏.首先,他让每个大臣在左.右 手上面分别写下一个整数,国王自己也在左.右手上各写一个整数.然后,让这 n 位大臣排 成一排,国王站在队伍 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
